]> git.ipfire.org Git - people/pmueller/ipfire-2.x.git/blob - make.sh
Alten PCMCIA Code aus dem Installer entfernt.
[people/pmueller/ipfire-2.x.git] / make.sh
1 #!/bin/bash
2 ############################################################################
3 # #
4 # This file is part of the IPFire Firewall. #
5 # #
6 # IPFire is free software; you can redistribute it and/or modify #
7 # it under the terms of the GNU General Public License as published by #
8 # the Free Software Foundation; either version 2 of the License, or #
9 # (at your option) any later version. #
10 # #
11 # IPFire is distributed in the hope that it will be useful, #
12 # but WITHOUT ANY WARRANTY; without even the implied warranty of #
13 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the #
14 # GNU General Public License for more details. #
15 # #
16 # You should have received a copy of the GNU General Public License #
17 # along with IPFire; if not, write to the Free Software #
18 # Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA #
19 # #
20 # Copyright (C) 2006 IPFire-Team <info@ipfire.eu>. #
21 # #
22 ############################################################################
23 #
24
25 NAME="IPFire" # Software name
26 SNAME="ipfire" # Short name
27 VERSION="2.0b" # Version number
28 SLOGAN="www.ipfire.org" # Software slogan
29 CONFIG_ROOT=/var/ipfire # Configuration rootdir
30 NICE=10 # Nice level
31 MAX_RETRIES=1 # prefetch/check loop
32 KVER=`grep --max-count=1 VER lfs/linux | awk '{ print $3 }'`
33 MACHINE=`uname -m`
34 SVN_REVISION=`svn info | grep Revision | cut -c 11-`
35
36 IPFVER="full" # Which versions should be compiled? (full|light|voice|devel)
37
38 # Set an information about the build number
39 if [ -e ./.svn ]; then
40 FIREBUILD=`cat .svn/entries |sed -n 's/^[ \t]*revision=\"// p' | sed -n 's/\".*$// p'`
41 fi
42
43 # Debian specific settings
44 if [ ! -e /etc/debian_version ]; then
45 FULLPATH=`which $0`
46 else
47 if [ -x /usr/bin/realpath ]; then
48 FULLPATH=`/usr/bin/realpath $0`
49 else
50 echo "ERROR: Need to do apt-get install realpath"
51 exit 1
52 fi
53 fi
54
55 PWD=`pwd`
56 BASENAME=`basename $0`
57 BASEDIR=`echo $FULLPATH | sed "s/\/$BASENAME//g"`
58 LOGFILE=$BASEDIR/log/_build.preparation.log
59 export BASEDIR LOGFILE
60 DIR_CHK=$BASEDIR/cache/check
61 mkdir $BASEDIR/log/ 2>/dev/null
62
63 # Include funtions
64 . tools/make-functions
65
66 if [ -f .config ]; then
67 . .config
68 else
69 echo -e "${BOLD}No configuration found!${NORMAL}"
70 echo -ne "Do you want to create one (y/N)?"
71 read CREATE_CONFIG
72 echo ""
73 if [ "$CREATE_CONFIG" == "y" ]; then
74 make_config
75 fi
76 fi
77
78 prepareenv() {
79 ############################################################################
80 # #
81 # Are we running the right shell? #
82 # #
83 ############################################################################
84 if [ ! "$BASH" ]; then
85 exiterror "BASH environment variable is not set. You're probably running the wrong shell."
86 fi
87
88 if [ -z "${BASH_VERSION}" ]; then
89 exiterror "Not running BASH shell."
90 fi
91
92
93 ############################################################################
94 # #
95 # Trap on emergency exit #
96 # #
97 ############################################################################
98 trap "exiterror 'Build process interrupted'" SIGINT SIGTERM SIGKILL SIGSTOP SIGQUIT
99
100
101 ############################################################################
102 # #
103 # Resetting our nice level #
104 # #
105 ############################################################################
106 echo -ne "Resetting our nice level to $NICE" | tee -a $LOGFILE
107 renice $NICE $$ > /dev/null
108 if [ `nice` != "$NICE" ]; then
109 beautify message FAIL
110 exiterror "Failed to set correct nice level"
111 else
112 beautify message DONE
113 fi
114
115
116 ############################################################################
117 # #
118 # Checking if running as root user #
119 # #
120 ############################################################################
121 echo -ne "Checking if we're running as root user" | tee -a $LOGFILE
122 if [ `id -u` != 0 ]; then
123 beautify message FAIL
124 exiterror "Not building as root"
125 else
126 beautify message DONE
127 fi
128
129
130 ############################################################################
131 # #
132 # Checking for necessary temporary space #
133 # #
134 ############################################################################
135 echo -ne "Checking for necessary space on disk $BASE_DEV" | tee -a $LOGFILE
136 BASE_DEV=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $1 }'`
137 BASE_ASPACE=`df -P -k $BASEDIR | tail -n 1 | awk '{ print $4 }'`
138 if (( 2048000 > $BASE_ASPACE )); then
139 BASE_USPACE=`du -skx $BASEDIR | awk '{print $1}'`
140 if (( 2048000 - $BASE_USPACE > $BASE_ASPACE )); then
141 beautify message FAIL
142 exiterror "Not enough temporary space available, need at least 2GB on $BASE_DEV"
143 fi
144 else
145 beautify message DONE
146 fi
147
148 ############################################################################
149 # #
150 # Building Linux From Scratch system #
151 # #
152 ############################################################################
153 # Set umask
154 umask 022
155
156 # Set LFS Directory
157 LFS=$BASEDIR/build
158
159 # Check /tools symlink
160 if [ -h /tools ]; then
161 rm -f /tools
162 fi
163 if [ ! -a /tools ]; then
164 ln -s $BASEDIR/build/tools /
165 fi
166 if [ ! -h /tools ]; then
167 exiterror "Could not create /tools symbolic link."
168 fi
169
170 # Setup environment
171 set +h
172 LC_ALL=POSIX
173 MAKETUNING="-j4"
174 export LFS LC_ALL CFLAGS CXXFLAGS MAKETUNING
175 unset CC CXX CPP LD_LIBRARY_PATH LD_PRELOAD
176
177 # Make some extra directories
178 mkdir -p $BASEDIR/build/{tools,etc,usr/src} 2>/dev/null
179 mkdir -p $BASEDIR/build/{dev/{shm,pts},proc,sys}
180 mkdir -p $BASEDIR/{cache,ccache} 2>/dev/null
181 mkdir -p $BASEDIR/build/usr/src/{cache,config,doc,html,langs,lfs,log,src,ccache}
182
183 mknod -m 600 $BASEDIR/build/dev/console c 5 1 2>/dev/null
184 mknod -m 666 $BASEDIR/build/dev/null c 1 3 2>/dev/null
185
186 # Make all sources and proc available under lfs build
187 mount --bind /dev $BASEDIR/build/dev
188 mount --bind /dev/pts $BASEDIR/build/dev/pts
189 mount --bind /dev/shm $BASEDIR/build/dev/shm
190 mount --bind /proc $BASEDIR/build/proc
191 mount --bind /sys $BASEDIR/build/sys
192 mount --bind $BASEDIR/cache $BASEDIR/build/usr/src/cache
193 mount --bind $BASEDIR/ccache $BASEDIR/build/usr/src/ccache
194 mount --bind $BASEDIR/config $BASEDIR/build/usr/src/config
195 mount --bind $BASEDIR/doc $BASEDIR/build/usr/src/doc
196 mount --bind $BASEDIR/html $BASEDIR/build/usr/src/html
197 mount --bind $BASEDIR/langs $BASEDIR/build/usr/src/langs
198 mount --bind $BASEDIR/lfs $BASEDIR/build/usr/src/lfs
199 mount --bind $BASEDIR/log $BASEDIR/build/usr/src/log
200 mount --bind $BASEDIR/src $BASEDIR/build/usr/src/src
201
202 # This is a temporary hack!!!
203 if [ ! -f /tools/bin/hostname ]; then
204 cp -f /bin/hostname /tools/bin/hostname 2>/dev/null
205 fi
206
207 # Run LFS static binary creation scripts one by one
208 export CCACHE_DIR=$BASEDIR/ccache
209 export CCACHE_HASHDIR=1
210
211 # Remove pre-install list of installed files in case user erase some files before rebuild
212 rm -f $BASEDIR/build/usr/src/lsalr 2>/dev/null
213 }
214
215 buildtoolchain() {
216 LOGFILE="$BASEDIR/log/_build.toolchain.log"
217 export LOGFILE
218 ORG_PATH=$PATH
219 NATIVEGCC=`gcc --version | grep GCC | awk {'print $3'}`
220 export NATIVEGCC GCCmajor=${NATIVEGCC:0:1} GCCminor=${NATIVEGCC:2:1} GCCrelease=${NATIVEGCC:4:1}
221 lfsmake1 ccache
222 lfsmake1 binutils PASS=1
223 lfsmake1 gcc PASS=1
224 export PATH=$BASEDIR/build/usr/local/bin:$BASEDIR/build/tools/bin:$PATH
225 lfsmake1 linux-libc-header
226 lfsmake1 glibc
227 lfsmake1 cleanup-toolchain PASS=1
228 lfsmake1 tcl
229 lfsmake1 expect
230 lfsmake1 dejagnu
231 lfsmake1 gcc PASS=2
232 lfsmake1 binutils PASS=2
233 lfsmake1 ncurses
234 lfsmake1 bash
235 lfsmake1 bzip2
236 lfsmake1 coreutils
237 lfsmake1 diffutils
238 lfsmake1 findutils
239 lfsmake1 gawk
240 lfsmake1 gettext
241 lfsmake1 grep
242 lfsmake1 gzip
243 lfsmake1 m4
244 lfsmake1 make
245 lfsmake1 patch
246 lfsmake1 perl
247 lfsmake1 sed
248 lfsmake1 tar
249 lfsmake1 texinfo
250 lfsmake1 util-linux
251 lfsmake1 cleanup-toolchain PASS=2
252 export PATH=$ORG_PATH
253 }
254
255 buildbase() {
256 LOGFILE="$BASEDIR/log/_build.base.log"
257 export LOGFILE
258 lfsmake2 stage2
259 lfsmake2 linux-libc-header
260 lfsmake2 man-pages
261 lfsmake2 glibc
262 lfsmake2 cleanup-toolchain PASS=3
263 lfsmake2 binutils
264 lfsmake2 gcc
265 lfsmake2 berkeley
266 lfsmake2 coreutils
267 lfsmake2 iana-etc
268 lfsmake2 m4
269 lfsmake2 bison
270 lfsmake2 ncurses
271 lfsmake2 procps
272 lfsmake2 sed
273 lfsmake2 libtool
274 lfsmake2 perl
275 lfsmake2 readline
276 lfsmake2 zlib
277 lfsmake2 autoconf
278 lfsmake2 automake
279 lfsmake2 bash
280 lfsmake2 bzip2
281 lfsmake2 diffutils
282 lfsmake2 e2fsprogs
283 lfsmake2 ed
284 lfsmake2 file
285 lfsmake2 findutils
286 lfsmake2 flex
287 lfsmake2 gawk
288 lfsmake2 gettext
289 lfsmake2 grep
290 lfsmake2 groff
291 lfsmake2 gzip
292 lfsmake2 inetutils
293 lfsmake2 iproute2
294 lfsmake2 kbd
295 lfsmake2 less
296 lfsmake2 libaal
297 lfsmake2 make
298 lfsmake2 man
299 lfsmake2 mktemp
300 lfsmake2 modutils
301 lfsmake2 net-tools
302 lfsmake2 patch
303 lfsmake2 psmisc
304 lfsmake2 reiser4progs
305 lfsmake2 shadow
306 lfsmake2 sysklogd
307 lfsmake2 sysvinit
308 lfsmake2 tar
309 lfsmake2 texinfo
310 lfsmake2 udev
311 lfsmake2 util-linux
312 lfsmake2 vim
313 lfsmake2 grub
314 }
315
316 buildipfire() {
317 LOGFILE="$BASEDIR/log/_build.ipfire.log"
318 export LOGFILE
319 ipfiremake configroot
320 ipfiremake dhcp
321 ipfiremake dhcpcd
322 ipfiremake libusb
323 ipfiremake libpcap
324 ipfiremake linux-atm
325 ipfiremake ppp
326 ipfiremake rp-pppoe
327 ipfiremake unzip
328 ipfiremake linux SMP=1
329 ipfiremake ipp2p SMP=1
330 ipfiremake fcdsl SMP=1
331 ipfiremake fcdsl2 SMP=1
332 ipfiremake fcdslsl SMP=1
333 ipfiremake fcdslusb SMP=1
334 ipfiremake fcdslslusb SMP=1
335 ipfiremake fcpci SMP=1
336 # ipfiremake promise-sata-300-tx SMP=1
337 ipfiremake zaptel SMP=1
338 ipfiremake fuse SMP=1
339 ipfiremake linux
340 ipfiremake ipp2p
341 ipfiremake fcdsl
342 ipfiremake fcdsl2
343 ipfiremake fcdslsl
344 ipfiremake fcdslusb
345 ipfiremake fcdslslusb
346 ipfiremake fcpci
347 # ipfiremake promise-sata-300-tx
348 ipfiremake zaptel
349 ipfiremake fuse
350 ipfiremake pkg-config
351 ipfiremake expat
352 ipfiremake gdbm
353 ipfiremake gmp
354 ipfiremake pam
355 ipfiremake openssl
356 ipfiremake python
357 ipfiremake libnet
358 ipfiremake libjpeg
359 ipfiremake libpng
360 ipfiremake libtiff
361 ipfiremake lcms
362 ipfiremake libmng
363 ipfiremake freetype
364 ipfiremake libart
365 ipfiremake gd
366 ipfiremake popt
367 ipfiremake pcre
368 ipfiremake slang
369 ipfiremake newt
370 ipfiremake libcap
371 ipfiremake pciutils
372 ipfiremake libxml2
373 ipfiremake BerkeleyDB
374 ipfiremake mysql
375 ipfiremake cyrus-sasl
376 ipfiremake openldap
377 ipfiremake apache2
378 ipfiremake php
379 ipfiremake apache2 PASS=C
380 ipfiremake arping
381 ipfiremake beep
382 ipfiremake bind
383 ipfiremake capi4k-utils
384 ipfiremake cdrtools
385 ipfiremake dnsmasq
386 ipfiremake libaal
387 ipfiremake dosfstools
388 ipfiremake reiserfsprogs
389 ipfiremake squashfstools
390 ipfiremake sysfsutils
391 ipfiremake ntfs-3g
392 ipfiremake ethtool
393 ipfiremake ez-ipupdate
394 ipfiremake fcron
395 ipfiremake GD
396 ipfiremake gnupg
397 ipfiremake hdparm
398 ipfiremake ibod
399 ipfiremake initscripts
400 ipfiremake iptables
401 ipfiremake libupnp
402 ipfiremake ipp2p IPT=1
403 ipfiremake moblock
404 ipfiremake linux-igd
405 ipfiremake ipac-ng
406 ipfiremake ipaddr
407 ipfiremake iptstate
408 ipfiremake iputils
409 ipfiremake l7-protocols
410 ipfiremake isapnptools
411 # ipfiremake isdn4k-utils # What about mISDN???
412 ipfiremake hwdata
413 ipfiremake kudzu
414 ipfiremake logrotate
415 ipfiremake logwatch
416 ipfiremake misc-progs
417 ipfiremake mtools
418 ipfiremake nano
419 ipfiremake nash
420 ipfiremake nasm
421 ipfiremake URI
422 ipfiremake HTML-Tagset
423 ipfiremake HTML-Parser
424 ipfiremake Compress-Zlib
425 ipfiremake Digest
426 ipfiremake Digest-SHA1
427 ipfiremake Digest-HMAC
428 ipfiremake libwww-perl
429 ipfiremake Net-DNS
430 ipfiremake Net-IPv4Addr
431 ipfiremake Net_SSLeay
432 ipfiremake IO-Stringy
433 ipfiremake Unix-Syslog
434 ipfiremake Mail-Tools
435 ipfiremake MIME-Tools
436 ipfiremake Net-Server
437 ipfiremake Convert-TNEF
438 ipfiremake Convert-UUlib
439 ipfiremake Archive-Tar
440 ipfiremake Archive-Zip
441 ipfiremake Text-Tabs+Wrap
442 ipfiremake Locale-Country
443 ipfiremake XML-Parser
444 ipfiremake glib
445 ipfiremake dbus
446 ipfiremake hal
447 ipfiremake hwinfo
448 ipfiremake GeoIP
449 ipfiremake fwhits
450 ipfiremake noip_updater
451 ipfiremake ntp
452 ipfiremake oinkmaster
453 ipfiremake openssh
454 ipfiremake openswan
455 ipfiremake pptpclient
456 ipfiremake rrdtool
457 ipfiremake setserial
458 ipfiremake setup
459 ipfiremake snort
460 ipfiremake squid
461 ipfiremake squid-graph
462 ipfiremake squidguard
463 ipfiremake tcpdump
464 ipfiremake traceroute
465 ipfiremake vlan
466 ipfiremake wireless
467 ipfiremake libsafe
468 ipfiremake 3c5x9setup
469 ipfiremake pakfire
470 ipfiremake java
471 ipfiremake bootsplash
472 ipfiremake spandsp
473 ipfiremake lzo
474 ipfiremake openvpn
475 ipfiremake pammysql
476 ipfiremake xinetd
477 ipfiremake ghostscript
478 ipfiremake cups
479 ipfiremake samba
480 ipfiremake sudo
481 ipfiremake mc
482 ipfiremake wget
483 ipfiremake wput
484 ipfiremake bridge-utils
485 ipfiremake screen
486 ipfiremake hddtemp
487 ipfiremake smartmontools
488 ipfiremake htop
489 ipfiremake lynx
490 ipfiremake postfix
491 ipfiremake procmail
492 ipfiremake fetchmail
493 ipfiremake cyrusimap
494 ipfiremake webcyradm
495 ipfiremake mailx
496 ipfiremake clamav
497 ipfiremake razor
498 ipfiremake spamassassin
499 ipfiremake amavisd
500 ipfiremake stund
501 ipfiremake libpri
502 # ipfiremake bristuff
503 ipfiremake asterisk
504 ipfiremake mpg123
505 ipfiremake libmad
506 ipfiremake libogg
507 ipfiremake libvorbis
508 ipfiremake lame
509 ipfiremake xvid
510 ipfiremake mpeg2dec
511 ipfiremake ffmpeg
512 ipfiremake sox
513 ipfiremake gnump3d
514 ipfiremake videolan
515 ipfiremake applejuice
516 ipfiremake ocaml
517 ipfiremake mldonkey
518 ipfiremake ntop
519 ipfiremake rsync
520 ipfiremake tcpwrapper
521 ipfiremake portmap
522 ipfiremake nfs
523 ipfiremake nmap
524 ipfiremake mbmon
525 ipfiremake iftop
526 ipfiremake ncftp
527 ipfiremake cftp
528 ipfiremake etherwake
529 ipfiremake ethereal
530 ipfiremake tftp-hpa
531 ipfiremake iptraf
532 ipfiremake nagios
533 }
534
535 buildinstaller() {
536 # Run installer scripts one by one
537 LOGFILE="$BASEDIR/log/_build.installer.log"
538 export LOGFILE
539 ipfiremake syslinux
540 ipfiremake memtest
541 installmake linux-libc-header
542 installmake binutils
543 ipfiremake uClibc PASS=1
544 ipfiremake gcc INST=1
545 installmake uClibc PASS=2
546 installmake gcc INST=2
547 installmake uClibc PASS=3
548 installmake busybox
549 installmake udev
550 installmake slang
551 installmake newt
552 installmake gettext
553 installmake kbd
554 installmake popt
555 installmake sysvinit
556 installmake misc-progs
557 installmake e2fsprogs
558 installmake libaal
559 installmake reiser4progs
560 installmake reiserfsprogs
561 installmake sysfsutils
562 installmake util-linux
563 installmake pciutils
564 installmake zlib
565 installmake wget
566 installmake libxml2
567 installmake dbus
568 installmake hal
569 installmake hwdata
570 installmake hwinfo
571 installmake kudzu
572 installmake installer
573 installmake initrd
574 }
575
576 buildpackages() {
577 LOGFILE="$BASEDIR/log/_build.packages.log"
578 export LOGFILE
579 echo "... see detailed log in _build.*.log files" >> $LOGFILE
580
581 installmake strip
582
583 # Generating list of packages used
584 echo -n "Generating packages list from logs" | tee -a $LOGFILE
585 rm -f $BASEDIR/doc/packages-list
586 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
587 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
588 echo "* `basename $i`" >>$BASEDIR/doc/packages-list
589 fi
590 done
591 echo "== List of softwares used to build $NAME Version: $VERSION ==" > $BASEDIR/doc/packages-list.txt
592 grep -v 'configroot$\|img$\|initrd$\|initscripts$\|installer$\|install$\|setup$\|pakfire$\|stage2$\|smp$\|tools$\|tools1$\|tools2$\|.tgz$\|-config$\|_missing_rootfile$' \
593 $BASEDIR/doc/packages-list | sort >> $BASEDIR/doc/packages-list.txt
594 rm -f $BASEDIR/doc/packages-list
595 # packages-list.txt is ready to be displayed for wiki page
596 beautify message DONE
597
598 # Create images for install
599 for i in $IPFVER
600 do
601 if [ $i == "devel" ]; then
602 if [ ! -e ipfire-$VERSION.i586-devel.iso ]; then
603 ipfiremake cdrom ED=$i
604 fi
605 else
606 ipfiremake cdrom ED=$i
607 fi
608 done
609 ipfiremake pxe
610 cp -f $LFS/install/images/{*.iso,*.tgz} $BASEDIR >> $LOGFILE 2>&1
611
612 # ipfirepackages
613
614 # Cleanup
615 stdumount
616 rm -rf $BASEDIR/build/tmp/*
617
618 # Generating total list of files
619 echo "Generating files list from logs" | tee -a $LOGFILE
620 rm -f $BASEDIR/log/FILES
621 for i in `ls -1tr $BASEDIR/log/[^_]*`; do
622 if [ "$i" != "$BASEDIR/log/FILES" -a -n $i ]; then
623 echo "##" >>$BASEDIR/log/FILES
624 echo "## `basename $i`" >>$BASEDIR/log/FILES
625 echo "##" >>$BASEDIR/log/FILES
626 cat $i | sed "s%^\./%#%" | sort >> $BASEDIR/log/FILES
627 fi
628 done
629 cd $BASEDIR/packages; ls -w1 *.ipfire | awk -F ".ipfire" '{ print $1 }' > $BASEDIR/packages/packages_list.txt
630 echo -n "###EOF###" >> $BASEDIR/packages/packages_list.txt
631
632 cd $PWD
633
634 }
635
636 ipfirepackages() {
637 if [ -d "$BASEDIR/packages" ]; then
638 for i in `ls $BASEDIR/packages`; do
639 touch $BASEDIR/build/install/packages/$i.empty
640 done
641 fi
642 # ipfiredist amavisd
643 ipfiredist applejuice
644 ipfiredist asterisk
645 ipfiredist clamav
646 ipfiredist cups
647 ipfiredist cyrusimap
648 ipfiredist fetchmail
649 ipfiredist ffmpeg
650 ipfiredist gnump3d
651 ipfiredist iptraf
652 ipfiredist java
653 ipfiredist lame
654 ipfiredist libmad
655 ipfiredist libogg
656 ipfiredist libvorbis
657 ipfiredist mailx
658 ipfiredist mldonkey
659 ipfiredist mpeg2dec
660 ipfiredist nagios
661 ipfiredist nfs
662 ipfiredist nmap
663 ipfiredist ntop
664 ipfiredist portmap
665 ipfiredist postfix
666 ipfiredist procmail
667 ipfiredist samba
668 ipfiredist sox
669 ipfiredist spamassassin
670 ipfiredist subversion
671 ipfiredist videolan
672 ipfiredist webcyradm
673 ipfiredist xvid
674 ipfiredist yasuc
675 test -d $BASEDIR/packages || mkdir $BASEDIR/packages
676 mv -f $LFS/install/packages/*.{ipfire,md5} $BASEDIR/packages >> $LOGFILE 2>&1
677 rm -rf $BASEDIR/build/install/packages/*
678 }
679
680 # See what we're supposed to do
681 case "$1" in
682 build)
683 clear
684 BUILDMACHINE=`uname -m`
685 PACKAGE=`ls -v -r $BASEDIR/cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz 2> /dev/null | head -n 1`
686 #only restore on a clean disk
687 if [ ! -f log/cleanup-toolchain-2-tools ]; then
688 if [ ! -n "$PACKAGE" ]; then
689 beautify build_stage "Full toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
690 prepareenv
691 buildtoolchain
692 else
693 PACKAGENAME=${PACKAGE%.tar.gz}
694 beautify build_stage "Packaged toolchain compilation"
695 if [ `md5sum $PACKAGE | awk '{print $1}'` == `cat $PACKAGENAME.md5 | awk '{print $1}'` ]; then
696 tar zxf $PACKAGE
697 prepareenv
698 else
699 exiterror "$PACKAGENAME md5 did not match, check downloaded package"
700 fi
701 fi
702 else
703 echo -n "Using installed toolchain" | tee -a $LOGFILE
704 beautify message SKIP
705 prepareenv
706 fi
707
708 beautify build_start
709 beautify build_stage "Building LFS"
710 buildbase
711
712 beautify build_stage "Building IPFire"
713 buildipfire
714
715 # Setzen des IPFire Builds
716 if [ "$FIREBUILD" ]; then
717 echo "$FIREBUILD" > $BASEDIR/build/var/ipfire/firebuild
718 else
719 echo "_(OvO)_" > $BASEDIR/build/var/ipfire/firebuild
720 fi
721
722 beautify build_stage "Building installer"
723 buildinstaller
724
725 beautify build_stage "Building packages"
726 buildpackages
727 beautify build_end
728 ;;
729 shell)
730 # enter a shell inside LFS chroot
731 # may be used to changed kernel settings
732 prepareenv
733 entershell
734 ;;
735 changelog)
736 echo -n "Loading new Changelog from SVN: "
737 svn log http://svn.ipfire.org/svn/ipfire > doc/ChangeLog
738 beautify message DONE
739 ;;
740 clean)
741 echo -en "${BOLD}Cleaning build directory...${NORMAL}"
742 for i in `mount | grep $BASEDIR | sed 's/^.*loop=\(.*\))/\1/'`; do
743 $LOSETUP -d $i 2>/dev/null
744 done
745 for i in `mount | grep $BASEDIR | cut -d " " -f 1`; do
746 umount $i
747 done
748 stdumount
749 for i in `seq 0 7`; do
750 if ( losetup /dev/loop${i} 2>/dev/null | grep -q "/install/images" ); then
751 umount /dev/loop${i} 2>/dev/null;
752 losetup -d /dev/loop${i} 2>/dev/null;
753 fi;
754 done
755 rm -rf $BASEDIR/build
756 rm -rf $BASEDIR/cdrom
757 rm -rf $BASEDIR/packages
758 rm -rf $BASEDIR/log
759 if [ -h /tools ]; then
760 rm -f /tools
761 fi
762 beautify message DONE
763 ;;
764 downloadsrc)
765 if [ ! -d $BASEDIR/cache ]; then
766 mkdir $BASEDIR/cache
767 fi
768 mkdir -p $BASEDIR/log
769 echo -e "${BOLD}Preload all source files${NORMAL}" | tee -a $LOGFILE
770 FINISHED=0
771 cd $BASEDIR/lfs
772 for c in `seq $MAX_RETRIES`; do
773 if (( FINISHED==1 )); then
774 break
775 fi
776 FINISHED=1
777 cd $BASEDIR/lfs
778 for i in *; do
779 if [ -f "$i" -a "$i" != "Config" ]; then
780 echo -ne "Loading $i"
781 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t ($c/$MAX_RETRIES)" download >> $LOGFILE 2>&1
782 if [ $? -ne 0 ]; then
783 beautify message FAIL
784 FINISHED=0
785 else
786 if [ $c -eq 1 ]; then
787 beautify message DONE
788 fi
789 fi
790 fi
791 done
792 done
793 echo -e "${BOLD}***Verifying md5sums${NORMAL}"
794 ERROR=0
795 for i in *; do
796 if [ -f "$i" -a "$i" != "Config" ]; then
797 make -s -f $i LFS_BASEDIR=$BASEDIR MESSAGE="$i\t " md5 >> $LOGFILE 2>&1
798 if [ $? -ne 0 ]; then
799 echo -ne "MD5 difference in lfs/$i"
800 beautify message FAIL
801 ERROR=1
802 fi
803 fi
804 done
805 if [ $ERROR -eq 0 ]; then
806 echo -ne "${BOLD}all files md5sum match${NORMAL}"
807 beautify message DONE
808 else
809 echo -ne "${BOLD}not all files were correctly download${NORMAL}"
810 beautify message FAIL
811 fi
812 cd - >/dev/null 2>&1
813 ;;
814 toolchain)
815 clear
816 prepareenv
817 beautify build_stage "Toolchain compilation - Native GCC: `gcc --version | grep GCC | awk {'print $3'}`"
818 buildtoolchain
819 BUILDMACHINE=`uname -m`
820 echo "`date -u '+%b %e %T'`: Create toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
821 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
822 cd $BASEDIR && tar -zc --exclude='log/_build.*.log' -f cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
823 build/{bin,etc,usr/bin,usr/local} \
824 build/tools/{bin,etc,*-linux-gnu,include,lib,libexec,sbin,share,var} \
825 log >> $LOGFILE
826 md5sum cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.tar.gz \
827 > cache/toolchains/$SNAME-$VERSION-toolchain-$BUILDMACHINE.md5
828 stdumount
829 ;;
830 gettoolchain)
831 BUILDMACHINE=`uname -m`
832 # arbitrary name to be updated in case of new toolchain package upload
833 PACKAGE=$SNAME-$VERSION-toolchain-$BUILDMACHINE
834 if [ ! -f $BASEDIR/cache/toolchains/$PACKAGE.tar.gz ]; then
835 URL_TOOLCHAIN=`grep URL_TOOLCHAIN lfs/Config | awk '{ print $3 }'`
836 test -d $BASEDIR/cache/toolchains || mkdir $BASEDIR/cache/toolchains
837 echo "`date -u '+%b %e %T'`: Load toolchain tar.gz for $BUILDMACHINE" | tee -a $LOGFILE
838 cd $BASEDIR/cache/toolchains
839 wget $URL_TOOLCHAIN/$PACKAGE.tar.gz $URL_TOOLCHAIN/$PACKAGE.md5 >& /dev/null
840 if [ $? -ne 0 ]; then
841 echo "`date -u '+%b %e %T'`: error downloading toolchain for $BUILDMACHINE machine" | tee -a $LOGFILE
842 else
843 if [ "`md5sum $PACKAGE.tar.gz | awk '{print $1}'`" = "`cat $PACKAGE.md5 | awk '{print $1}'`" ]; then
844 echo "`date -u '+%b %e %T'`: toolchain md5 ok" | tee -a $LOGFILE
845 else
846 exiterror "$PACKAGE.md5 did not match, check downloaded package"
847 fi
848 fi
849 else
850 echo "Toolchain is already downloaded. Exiting..."
851 fi
852 ;;
853 othersrc)
854 prepareenv
855 echo -ne "`date -u '+%b %e %T'`: Build sources iso for $MACHINE" | tee -a $LOGFILE
856 chroot $LFS /tools/bin/env -i HOME=/root \
857 TERM=$TERM PS1='\u:\w\$ ' \
858 PATH=/usr/local/bin:/bin:/usr/bin:/sbin:/usr/sbin \
859 VERSION=$VERSION NAME="$NAME" SNAME="$SNAME" MACHINE=$MACHINE \
860 /bin/bash -x -c "cd /usr/src/lfs && make -f sources-iso LFS_BASEDIR=/usr/src install" >>$LOGFILE 2>&1
861 mv $LFS/install/images/ipfire-* $BASEDIR >> $LOGFILE 2>&1
862 if [ $? -eq "0" ]; then
863 beautify message DONE
864 else
865 beautify message FAIL
866 fi
867 stdumount
868 ;;
869 svn)
870 case "$2" in
871 update|up)
872 # clear
873 echo -ne "Loading the latest source files...\n"
874 if [ $3 ]; then
875 svn update -r $3 | tee -a $PWD/log/_build.svn.update.log
876 else
877 svn update | tee -a $PWD/log/_build.svn.update.log
878 fi
879 if [ $? -eq "0" ]; then
880 beautify message DONE
881 else
882 beautify message FAIL
883 exit 1
884 fi
885 echo -ne "Writing the svn-info to a file"
886 svn info > $PWD/svn_status
887 if [ $? -eq "0" ]; then
888 beautify message DONE
889 else
890 beautify message FAIL
891 exit 1
892 fi
893 chmod 755 $0
894 exit 0
895 ;;
896 commit|ci)
897 clear
898 if [ -f /usr/bin/mcedit ]; then
899 export EDITOR=/usr/bin/mcedit
900 fi
901 if [ -f /usr/bin/nano ]; then
902 export EDITOR=/usr/bin/nano
903 fi
904 echo -ne "Selecting editor $EDITOR..."
905 beautify message DONE
906 if [ -e /sbin/yast ]; then
907 if [ "`echo $SVN_REVISION | cut -c 3`" -eq "0" ]; then
908 $0 changelog
909 fi
910 fi
911 svn commit
912 $0 svn up
913 $0 uploadsrc
914 ;;
915 dist)
916 if [ $3 ]; then
917 SVN_REVISION=$3
918 fi
919 if [ -f ipfire-source-r$SVN_REVISION.tar.gz ]; then
920 echo -ne "REV $SVN_REVISION: SKIPPED!\n"
921 exit 0
922 fi
923 echo -en "REV $SVN_REVISION: Downloading..."
924 svn export http://svn.ipfire.org/svn/ipfire/trunk ipfire-source/ --force > /dev/null
925 svn log http://svn.ipfire.org/svn/ipfire/trunk -r 1:$SVN_REVISION > ipfire-source/Changelog
926 #svn info http://svn.ipfire.org/svn/ipfire/trunk -r $SVN_REVISION > ipfire-source/svn_status
927 evaluate 1
928
929 echo -en "REV $SVN_REVISION: Compressing files..."
930 if [ -e ipfire-source/trunk/make.sh ]; then
931 chmod 755 ipfire-source/trunk/make.sh
932 fi
933 tar cfz ipfire-source-r$SVN_REVISION.tar.gz ipfire-source
934 evaluate 1
935 echo -en "REV $SVN_REVISION: Cleaning up..."
936 rm ipfire-source/ -r
937 evaluate 1
938 ;;
939 diff|di)
940 echo -ne "Make a local diff to last svn revision"
941 svn diff > ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff
942 evaluate 1
943 echo "Diff was successfully saved to ipfire-diff-`date +'%Y-%m-%d-%H:%M'`-r`svn info | grep Revision | cut -c 11-`.diff"
944 ;;
945 esac
946 ;;
947 uploadsrc)
948 PWD=`pwd`
949 cd $BASEDIR/cache/
950 echo -e "Uploading cache to ftp server:"
951 ncftpls -u $FTP_CACHE_USER -p $FTP_CACHE_PASS ftp://$FTP_CACHE_URL$FTP_CACHE_PATH/ > /tmp/ftplist
952 for i in *; do
953 if [ "$i" == "toolchains" ]; then continue; fi
954 grep -q $i /tmp/ftplist
955 if [ "$?" -ne "0" ]; then
956 echo -ne "$i"
957 ncftpput -u $FTP_CACHE_USER -p $FTP_CACHE_PASS $FTP_CACHE_URL $FTP_CACHE_PATH/ $i
958 if [ "$?" -ne "0" ]; then
959 beautify message FAIL
960 fi
961 fi
962 done
963 rm -f /tmp/ftplist
964 cd $PWD
965 exit 0
966 ;;
967 upload)
968 case "$2" in
969 iso)
970 echo -e "Uploading the iso to $IPFIRE_FTP_URL_EXT."
971 cat <<EOF > .ftp-commands
972 mkdir $IPFIRE_FTP_PATH_EXT
973 ls -lah
974 quit
975 EOF
976 ncftp -u $IPFIRE_FTP_USER_EXT -p $IPFIRE_FTP_PASS_EXT $IPFIRE_FTP_URL_EXT < .ftp-commands
977 rm -f .ftp-commands
978 md5sum ipfire-install-$VERSION.i386.iso > ipfire-install-$VERSION.i386.iso.md5
979 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso
980 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-install-$VERSION.i386.iso.md5
981 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-source-r$SVN_REVISION.tar.gz
982 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ svn_status
983 if [ "$?" -eq "0" ]; then
984 echo -e "The iso of Revision $SVN_REVISION was successfully uploaded to $IPFIRE_FTP_URL_EXT$IPFIRE_FTP_PATH_EXT/."
985 else
986 echo -e "There was an error while uploading the iso to the ftp server."
987 exit 1
988 fi
989 if [ "$3" = "--with-sources-cd" ]; then
990 ncftpput -u $FTP_ISO_USER -p $FTP_ISO_PASS $FTP_ISO_URL $FTP_ISO_PATH/ ipfire-sources-cd-$VERSION.$MACHINE.iso
991 fi
992 ;;
993 paks)
994 cat <<EOF > .ftp-commands
995 mkdir $IPFIRE_FTP_PATH_PAK
996 ls -lah
997 quit
998 EOF
999 ncftp -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK < .ftp-commands
1000 rm -f .ftp-commands
1001 ncftpput -z -u $IPFIRE_FTP_USER_PAK -p $IPFIRE_FTP_PASS_PAK $IPFIRE_FTP_URL_PAK $IPFIRE_FTP_PATH_PAK/ packages/*
1002 if [ "$?" -eq "0" ]; then
1003 echo -e "The packages were successfully uploaded to $IPFIRE_FTP_URL_PAK$IPFIRE_FTP_PATH_PAK/."
1004 else
1005 echo -e "There was an error while uploading the packages to the ftp server."
1006 exit 1
1007 fi
1008 ;;
1009 esac
1010 ;;
1011 batch)
1012 if [ "$2" = "--background" ]; then
1013 batch_script
1014 exit $?
1015 fi
1016 if [ `screen -ls | grep -q ipfire` ]; then
1017 echo "Build is already running, sorry!"
1018 exit 1
1019 else
1020 if [ "$2" = "--rebuild" ]; then
1021 export IPFIRE_REBUILD=1
1022 echo "REBUILD!"
1023 else
1024 export IPFIRE_REBUILD=0
1025 fi
1026 echo -en "${BOLD}***IPFire-Batch-Build is starting...${NORMAL}"
1027 screen -dmS ipfire $0 batch --background
1028 evaluate 1
1029 exit 0
1030 fi
1031 ;;
1032 watch)
1033 watch_screen
1034 ;;
1035 pxe)
1036 case "$2" in
1037 start)
1038 start_tftpd
1039 ;;
1040 stop)
1041 stop_tftpd
1042 ;;
1043 reload|restart)
1044 reload_tftpd
1045 ;;
1046 esac
1047 exit 0
1048 ;;
1049 "")
1050 clear
1051 svn info
1052 select name in "Exit" "IPFIRE: Downloadsrc" "IPFIRE: Build (silent)" "IPFIRE: Watch Build" "IPFIRE: Batch" "IPFIRE: Clean" "SVN: Commit" "SVN: Update" "SVN: Status" "SVN: Diff" "LOG: Tail" "Help"
1053 do
1054 case $name in
1055 "IPFIRE: Downloadsrc")
1056 $0 downloadsrc
1057 ;;
1058 "IPFIRE: Build (silent)")
1059 $0 build-silent
1060 ;;
1061 "IPFIRE: Watch Build")
1062 $0 watch
1063 ;;
1064 "IPFIRE: Batch")
1065 $0 batch
1066 ;;
1067 "IPFIRE: Clean")
1068 $0 clean
1069 ;;
1070 "SVN: Update")
1071 $0 svn update
1072 ;;
1073 "Help")
1074 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1075 cat doc/make.sh-usage
1076 ;;
1077 "LOG: Tail")
1078 tail -f log/_*
1079 ;;
1080 "Exit")
1081 break
1082 ;;
1083 esac
1084 done
1085 ;;
1086 config)
1087 make_config
1088 ;;
1089 *)
1090 echo "Usage: $0 {build|changelog|clean|gettoolchain|downloadsrc|shell|sync|toolchain}"
1091 cat doc/make.sh-usage
1092 ;;
1093 esac